var Player = COM.createObject("wmplayer.ocx");
var Playlist, origPlaylist, IsPlaylist, PlayCounter;
COM.connectObject(Player, "WMP_");
Player.settings.setMode("loop", false);
Player.settings.autoStart = false;
var CDROM = Player.cdromCollection;
var Status = "stopped";
var isAudioCD = false;
//var skin ;
var curSound ;

var menu = new Array();
menu.push(new MenuItem());
menu[0].title = "Select a File...";
menu[0].onSelect = "PlayFile(chooseFile())";
menu.push(new MenuItem());
menu[1].title = "Select a Folder...";
menu[1].onSelect = "PlayFolder(chooseFolder());";
for(var i = 0; i < CDROM.count; i++) {
	var m = new MenuItem();
	m.title = "Audio CD Drive ("+ CDROM.Item(i).driveSpecifier +")";
	m.onSelect = "PlayAudioCD(" + i + ", CDROM.Item("+ i +").Playlist)"
	menu.push(m);
}

m = new MenuItem();
m.title = "----------------------------";
m.enabled=false;
menu.push(m);


m = new MenuItem();
m.title = "Change skin";
m.onSelect = "showChangeSkin()";
menu.push(m);

/*
m = new MenuItem();
m.title = "Select background";
m.onSelect = "showBGColor()";
menu.push(m);
*/

function setSkin() {
	
	var skin = preferences.skin.value;
	print("setSkin: "+skin)
	
	if(skin==-1){
	    background.src = "Resources/skins/0.png";
		background.colorize = preferences.bgColor.value;
		//print("setSkin: btnPlay.colorize="+preferences.buttonsColor.value)
		//btnPlay.colorize=btnStop.colorize=btnPrev.colorize=btnNext.colorize=btnMenu.colorize=btnSound.colorize=btnMinus.colorize=btnPlus.colorize=preferences.buttonsColor.value;

		}
	
	else{
		background.src = "Resources/skins/" + skin + ".png";
		background.colorize = "";
		//btnPlay.colorize=btnStop.colorize=btnPrev.colorize=btnNext.colorize=btnMenu.colorize=btnSound.colorize=btnMinus.colorize=btnPlus.colorize="";
		}
		
	//preferences.skin.value = skin;
	updateVitality()

}

 function  updateVitality(){ 
   	    doc = XMLDOM.parse(filesystem.readFile("vitality.xml"));
   	 	//print("updateVitality: "+chosenSign+"  doc="+doc)
   		icon = doc.getElementById("img");
   		icon.setAttribute("src", "Resources/icons/"+preferences.skin.value+".png");
   		widget.setDockItem(doc);
   	
 }




function init() {
	
	Player.settings.mute = false;
	//skin = preferences.skin.value;
	//print("skin="+skin)
	setSkin();
		
	curSound = preferences.volume.value;
	setSound(curSound)

	if(preferences.lastFolder.value != "") PlayFolder(preferences.lastFolder.value);
	else if (preferences.lastFile.value != "") PlayFile(preferences.lastFile.value);
	
	else{

		songName.data = "Drag a music file or folder here, or click the Menu button";

		volumeValue.opacity = 0;
		btnSound.opacity = 100;  btnMinus.opacity = 100;  btnPlus.opacity = 100;	

		changeCtrlPanelState("standby");
	}
	
		volumeValue.src = "Resources/screenButtons/volume_"+curSound+".png"
		//thumbIm.hOffset = Number(curSound/2)+Number(trackIm.hOffset)-Number(thumbIm.width/2)	
		print("init:: btnMenu.onMouseUp")
		btnMenu.onMouseUp = "popupMenu(menu, system.event.hOffset, system.event.vOffset+7);";
	
}




function setSound(value) {
    //print("setSound:"+value)
	Player.settings.volume = value;
	//volumeValue.data = Player.settings.volume + "%";
	
	volumeValue.src = "Resources/screenButtons/volume_"+value+".png"

	
	preferences.volume.value = value;
}

function mute() {
	if (Player.settings.mute) {
		Player.settings.mute = false;
		btnSound.src = 'Resources/controlButtons/btnMute.png'
		btnSound.tooltip = "Mute";
		setSound(preferences.volume.value)
		
	} 
	else {
		Player.settings.mute = true;
		btnSound.src = 'Resources/controlButtons/btnSound.png' 
		btnSound.tooltip = "Unmute";
		volumeValue.src = "Resources/screenButtons/mute_screen.png"
		
	}
}

function WMP_PlayStateChange(state) {
	if(state == 8) {
		// stopped
		Timer1.ticking = false;
		if(IsPlaylist || ((PlayCounter + 1) >= Playlist.length)) {
		    if(isFile){
		    					
					//Player.settings.setMode("autoRewind", true);
					stopSong();
					percentageBar.width = 0 //a hack, but it works...

		    }
		    else{
			PlayCounter = 0;
			Player.URL = null;
			position.data ="";
			duration.data = "";
			songName.data = "Drag a music file or folder here, or click the Menu button";
			volumeValue.opacity = 0;
			btnSound.opacity = 100;  btnMinus.opacity = 100;  btnPlus.opacity = 100;
			changeCtrlPanelState("standby")
			}
		} else {
			Timer2.ticking = true;
		}
	} else if(state == 10) {
		// ready
		Timer1.ticking = true;
	}
	else if(state == 3) {
		// playing
		duration.data = "/ "+ Player.currentMedia.durationString;
	
		if (! isAudioCD) {
			var artist = Player.currentMedia.getItemInfobyAtom(Player.mediaCollection.getMediaAtom("Artist"));
			//print("artist="+artist+";")
			var str;
			if(artist!='')
				 str = artist+" - "+Player.currentMedia.name;
		    else
		    	 str = Player.currentMedia.name
			songName.data = str;//.toUpperCase();
			volumeValue.opacity = 255;
			btnSound.opacity = 255;  btnMinus.opacity = 255;  btnPlus.opacity = 255;

		}
		navPlayList();
	}
}


function FileMedia(path) {
	this.sourceURL = path;
}

var isFile = false;

function PlayFile(fn) {
    isFile = true;
	isAudioCD = false;
	if(fn.length > 4) {
		var ext = fn.substr(fn.length - 3).toLowerCase();
		IsPlaylist = (ext == "m3u") || (ext == "wpl") || (ext == "wax");
	} else {
		IsPlaylist = false;
	}
	if(IsPlaylist) {
		Player.URL = fn;
		Player.controls.play();
		PlayCounter = 0;
	} else {
		Playlist = new Array(1);
		Playlist[0] = new FileMedia(fn);
		PlayMedia(0);
	}
	changeCtrlPanelState("playing")
	
	btnShuffle.opacity = 100;
	btnShuffle.onMouseUp = "";
	shuffleIcon.opacity=0;
	
	saveFile(fn);
	
}

function PlayFolder(path) {
    isFile = false
	isAudioCD = false;
	IsPlaylist = false;
	var fs = filesystem.getDirectoryContents(path, true);
	tmpList = new Array(fs.length);
	dirList = new Array(fs.length);
	var idxFile = 0;
	var idxFolder = 0;
	for(var i = 0; i < fs.length; i++) {
		if (! filesystem.isDirectory(path + "\\" + fs[i])) {
			for (n = fs[i].length; n > 0; n--) {
				if(fs[i].substring(n-1,n) == ".") {
					var idxExt = n;
					break;
				}
			}
			var ext = fs[i].substring(idxExt, fs[i].length).toLowerCase();
			if (ext == "mp3" || ext == "wav" || ext == "wma" || ext == "aif" || ext == "aiff" || ext == "au" || ext == "snd") {
				IsSong = true;
			} else {
				IsSong = false;
			}
			if (IsSong) {
				tmpList[idxFile] = new FileMedia(path + "\\" + fs[i]);
				idxFile++;
			}
		} else {
			dirList[idxFolder] = new FileMedia(path + "\\" + fs[i]);
			idxFolder++;
		}
	}
	if (idxFile > 0) {
		Playlist = new Array(idxFile);
		for(var i = 0; i < idxFile; i++) {
			Playlist[i] = tmpList[i];
		}
		
		origPlaylist = new Array(idxFile);//save for the 'unshuffle' option
		for(var i = 0; i < idxFile; i++) 
				origPlaylist[i] = Playlist[i];

		
		btnShuffle.opacity = 255;
		btnShuffle.onMouseUp = "shuffle ();";
		
		
		saveDirectory(path);
		changeCtrlPanelState("playing");
		PlayMedia(0);
	}
}

function saveDirectory(folderPath){
	if (folderPath != preferences.lastFolder.value) {
		if (folderPath != "") {
			folderPath = folderPath + "\\";
		}
		preferences.lastFile.value = "";
		preferences.lastFolder.value = folderPath;
	} else{
		return;
	}
}

function saveFile(filePath) {
    preferences.lastFolder.value = "";
	preferences.lastFile.value = filePath;
}

function PlayAudioCD(cdDriver, pList) {
	isAudioCD = true;
	IsPlaylist = false;
	IsPlaylist = false;
	oCDROM = CDROM.Item(cdDriver);
	colPlaylist = oCDROM.Playlist;
	Playlist = new Array(pList.count);
	cdPlaylistTitles = new Array(pList.count);
	for(var i = 0; i < pList.count; i++) {
		Playlist[i] = pList.Item(i);
		objSong = colPlaylist.Item(i);
		cdPlaylistTitles[i] = objSong.getItemInfo("title");
	}
	
	origPlaylist = new Array(pList.count);//save for the 'unshuffle' option
	for(var i = 0; i < pList.count; i++) 
			origPlaylist[i] = Playlist[i];
		

	changeCtrlPanelState("playing");
	PlayMedia(0);
	
	btnShuffle.opacity = 255;
	btnShuffle.onMouseUp = "shuffle ();";
	
}

function PlayMedia(i) {
	if (isAudioCD) {
		songName.data = cdPlaylistTitles[i].toUpperCase();
		volumeValue.opacity = 255;
		btnSound.opacity = 255;  btnMinus.opacity = 255;  btnPlus.opacity = 255;
	}
	print("PlayMedia "+i)
	PlayCounter = i;
	Player.URL = Playlist[i].sourceURL;
	Player.controls.play();
}

function playSong() {
    stopSong(); //first free resources
    print("playSong:: Status="+Status)
	if(Status != "playing") {
		Player.controls.play();
		Timer1.ticking = true;
		changeCtrlPanelState("playing")

	}
	else {
		Player.controls.pause();
		Timer1.ticking = false;
		changeCtrlPanelState("paused")
	}
}

function pauseSong() {
	if(Status == "playing") {
		Player.controls.pause();
		Timer1.ticking = false;
		changeCtrlPanelState("paused")
	}
}

function stopSong() {
	if(Status == "playing") {
		Player.controls.stop();
		Timer1.ticking = false;
		position.data ="00:00";
		changeCtrlPanelState("stopped")
	}
}

function getPreviousSong() {
	if(btnPrev.opacity != 100) {
		if(IsPlaylist) {
			PlayCounter--;
			Player.controls.previous();
		} else {
			PlayMedia(PlayCounter - 1);
		}
		changeCtrlPanelState("playing")
	}
}

function getNextSong() {
	if(btnNext.opacity != 100) {
		if(IsPlaylist) {
			PlayCounter++;
			Player.controls.next();
		} else {
			PlayMedia(PlayCounter + 1);
		}
		changeCtrlPanelState("playing")
	}
}

var isShuffle = false;


function shuffle() {

  if(isShuffle) {//unshuffle
  	  //print("UN shuffle")	
  	  isShuffle = false;
  	  
  	  shuffleIcon.opacity=0;

  	  var n = Playlist.length;
  	  Playlist = new Array(n);
	  for(var i = 0; i < n; i++) 
			Playlist[i] = origPlaylist[i];
  	  
  	  
  }
  
  else{
  
	  isShuffle = true;
	  
	  shuffleIcon.opacity=255;
	  
	  var i = Playlist.length;
	  if (i == 0) return false;
	  while (--i) {
		 var j = Math.floor( Math.random() * (i + 1));
		 var tempi = Playlist[i];
		 var tempj = Playlist[j];
		 Playlist[i] = tempj;
		 Playlist[j] = tempi;
			if (isAudioCD) {
				var objSongi = cdPlaylistTitles[i];
				var objSongj = cdPlaylistTitles[j];
				cdPlaylistTitles[i] = objSongj;
				cdPlaylistTitles[j] = objSongi;
			}
	   }
	   
	 //print("shuffle")	  
   }
   
	changeCtrlPanelState("playing")
	print("shuffle:  PlayCounter="+PlayCounter)
	PlayMedia(PlayCounter); //0
}


function navPlayList() {
	if (PlayCounter == 0) {
		btnPrev.opacity = 100;
		btnPrev.onMouseUp = "";
	} else {
		btnPrev.opacity = 255;
		btnPrev.onMouseUp = "getPreviousSong();";
	}
	if(IsPlaylist) {
		if ((PlayCounter + 1) >= Player.currentPlaylist.count) {
			btnNext.opacity = 100;
			btnNext.onMouseUp = "";
		} else {
			btnNext.opacity = 255;
			btnNext.onMouseUp = "getNextSong();";
		}
	} else {
		if ((PlayCounter + 1) >= Playlist.length) {
			btnNext.opacity = 100;
			btnNext.onMouseUp = "";
		} else {
			btnNext.opacity = 255;
			btnNext.onMouseUp = "getNextSong();";
		}
	}
}

function changeCtrlPanelState(newState) {
	switch (newState) {

		case "playing":
			Status= "playing";
			btnPlay.src = "Resources/controlButtons/btnPause.png";
			btnPlay.opacity = 255;
			btnPlay.onMouseUp = "pauseSong();";
			btnStop.opacity = 255;
			btnStop.onMouseUp = "stopSong();";
			navPlayList();
			break;

		case "paused":
			Status= "paused";
			btnPlay.src = "Resources/controlButtons/btnPlay.png";
			btnPlay.opacity = 255;
			btnPlay.onMouseUp = "playSong();";
			btnStop.opacity = 100;
			btnStop.onMouseUp = "";
			navPlayList();
			break;

		case "stopped":
			Status= "stopped";
			btnPlay.src = "Resources/controlButtons/btnPlay.png";
			btnPlay.opacity = 255;
			btnPlay.onMouseUp = "playSong();";
			btnStop.opacity = 100;
			btnStop.onMouseUp = "";
			navPlayList();
			break;

		case "standby":
			btnPlay.src = "Resources/controlButtons/btnPlay.png";
			btnPlay.opacity=100;
			btnPlay.onMouseUp = "";
			btnStop.opacity = 100;
			btnStop.onMouseUp = "";
			btnPrev.opacity = 100;
			btnPrev.onMouseUp = "";
			btnNext.opacity = 100;
			btnNext.onMouseUp = "";
			btnShuffle.opacity= 100;
			btnShuffle.onMouseUp = "";
			
			break;

		default:
			break;
	}
}


////////////////////////////////
var dropType = "reject";

		function dragCheck( theDragItems ){
		
			var hilight = true;

			if( theDragItems.length > 2 )
				hilight = false;

			if( theDragItems[ 0 ] != "filenames" )
				hilight = false;
			
			theDragItems[ 1 ] = theDragItems[ 1 ].toLowerCase();
			
			if( !filesystem.isDirectory( theDragItems[ 1 ] ) )
			{
	
				if( !theDragItems[ 1 ].match('/*\.(mp3|wav|wma|aif|aiff|au|snd|m3u|wpl|wax)$'))
					hilight = false;
				else
					dropType = "file";
			}
			else
				dropType = "folder";


			if( hilight )					
				screen.src = "Resources/screenButtons/screen_a.png";

			
			else
				dropType = "reject";
		}
		
		function doDrop( theDropItem ){
		    
		    stopSong()
		
			switch( dropType )
			{
				case "file":

					PlayFile(theDropItem[ 1 ] )
					//pauseImage.src = "Resources/Picture Frame/play.png";
					break;


				case "folder":

					//pauseImage.src = "Resources/Picture Frame/pause.png";
					//preferences.locationPref.value = theDropItem[ 1 ];
					PlayFolder(theDropItem[ 1 ] )
					break;



				case "reject":
					break;
			}
		}
		
function doMove() {

        var x = system.event.x ;
        
        var curX = Number(thumbIm.hOffset)+Number(x);
        
        if(curX<=Number(trackIm.hOffset))
        	curX=Number(trackIm.hOffset);
        
        else if((curX+Number(thumbIm.width/2))>=(Number(trackIm.hOffset)+Number(trackIm.width)))	
        	curX=Number(trackIm.hOffset)+Number(trackIm.width)-Number(thumbIm.width);
        	
	thumbIm.hOffset = curX;
}


var soundDir;
	

function doSetSound() {
		/*
        var x = system.event.x ;
        
        var curX = Number(thumbIm.hOffset)+Number(thumbIm.width/2)+Number(x);
        
        theSound = (Number(curX)-Number(trackIm.hOffset))*2;
        
        setSound(theSound);
        */
        if(soundDir==0){
        	curSound=Number(curSound)-Number(10);
        	if(curSound<0) curSound=0;
        	}
        else{
            curSound=Number(curSound)+Number(10);
        	if(curSound>100) curSound=100;
        }
                       
        setSound(curSound);
        
        
}

function updateVisualTrack(curPosString){


    var min = curPosString.substring(0, curPosString.indexOf(':'));
    var sec = curPosString.substring(curPosString.indexOf(':')+1, curPosString.length);
    
	var curSec=Number(min*60)+Number(sec);

	var durationStr = Player.currentMedia.durationString;	
    min = durationStr.substring(0, durationStr.indexOf(':'));
    sec = durationStr.substring(durationStr.indexOf(':')+1, durationStr.length);
	
	var durationSec=Number(min*60)+Number(sec);
	
	var percentage = Math.round(Number(curSec*100)/Number(durationSec))

	if(percentage>94) percentage=110 //dirty, but the length of the time track is 100...
	
	percentageBar.width = Number(percentage)
	
}

function showBGColor(){

	
		var formFields = new Array();


		formFields[0] = new FormField();
		formFields[0].title = 'Pick a background color:';
		formFields[0].type = 'Color';

			
		formResults = form(formFields, 'Choose background color', 'Done'); 
		
		if(formResults != null){ 
		
			//print("formResults="+formResults)
			
			preferences.skin.value = -1
			preferences.bgColor.value = formResults[0];
		
			
			setSkin();
			
			
		}//if(formResults != null)

	}	
	
function showChangeSkin(){

	var skinNames=new Array(3)
	skinNames[0]="Pinky"
	skinNames[1]="Strong Green"
	skinNames[2]="White Is Elegant"
	skinNames[3]="Flamenco"
	skinNames[4]="Gold"
	skinNames[5]="Heavy Metal"
	skinNames[6]="Copper"
	skinNames[7]="Super Hot"
	skinNames[8]="Bee"
	skinNames[9]="Classic Black"
	skinNames[10]="Deep Blue"
	skinNames[11]="Oak"
	skinNames[12]="Bloom"
	skinNames[13]="Chameleon"
	var nSkins = skinNames.length

	
		var formFields = new Array();


		
		formFields[0] = new FormField();
		formFields[0].title = 'Select a skin:';
		formFields[0].type = 'popup';
		formFields[0].option = new Array();
		for (i=0; i<nSkins;i++){
			formFields[0].option[i]=skinNames[i];
		}
		
		
		
		formResults = form(formFields, 'Select a skin', 'Done'); 
		
		if(formResults != null){ 
		
			//print("formResults="+formResults)
			
			 for(i=0; i<nSkins; i++) {
			 	if(formResults[0]==skinNames[i]) {
			 		
			 		preferences.skin.value = i;

			 	}
			 
			 }
			
			setSkin();
			
			
			
			
			
		}//if(formResults != null)

	}	




	
		
		
